//NINA_generateur_503f.js
//Une extension du script "NINA.jsx" d'Olav Martin Kvern
// 03.04.12 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Dessine une srie d'objets dcoratifs et geomtriques

//For more on NINA, see http://www.washington.edu/bibsys/mattf/nina/index.html

// dfinir la longueur des filets
var curD =  23;
// une liste, contenant les centres des NINAs
// A4 paysage
var offPos0 = new Array ([52.5, 49.5], [52.5, 148.5], [52.5, 247.5], [157.5, 49.5], [157.5, 148.5], [157.5, 247.5]);
// A4 portrait
var offPos1 = new Array ([51.5, 54.5], [51.5, 155.5], [148.5, 54.5], [148.5, 155.5], [245.5, 54.5], [245.5, 155.5]);
// mmoriser la version du logiciel
var appVers = (app.version[0])*1;

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// appeler la fonction qui lit les prfrences mmorises
var allPrefs  = getPrefs();
if (allPrefs != "") {
	var prefVal = allPrefs.split("\n");
	var nPts    = prefVal[0]*1;
	var aPlsS   = prefVal[1]*1;
	var aPlsE   = prefVal[2]*1;
	var bPls    = prefVal[3]*1;
	var orDoc   = prefVal[4]*1;
	var rb1     = 1;
	var rb2     = 0;
	if (orDoc  == 1) {
		rb1       = 0;
		rb2       = 1;
	}
}
else {
	// utiliser les valeurs par dfaut 
	// quand le fichier des prfrences n'existe pas
	var nPts  = 201;
	var aPlsS =   1;
	var aPlsE =  16;
	var bPls  = 161;
	var rb1   = 1;
	var rb2   = 0;
}

// appeler la fonction qui affiche le dialogue
var anArray = displayDialog(nPts, aPlsS, aPlsE, bPls, rb1, rb2);
var numOfLines  = anArray[0];
var aPulseStart = anArray[1];
var aPulseEnd   = anArray[2];
var bPulse      = anArray[3];
var orDoc       = anArray[4];

// vrifier les valeurs
if (aPulseStart > aPulseEnd) {
	var tmpPulse    = aPulseStart;
	var aPulseStart = aPulseEnd;
	var aPulseEnd   = tmpPulse;
}
if (aPulseEnd > bPulse) {
	var tmpPulse  = aPulseEnd;
	var aPulseEnd = bPulse;
	var bPulse    = tmpPulse;
}

// crer le document
curDoc = app.documents.add();
curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
curDoc.viewPreferences.verticalMeasurementUnits   = MeasurementUnits.millimeters;
if (orDoc == 0) {
	curDoc.documentPreferences.properties = {pageWidth:297, pageHeight:210, facingPages:false, masterTextFrame:false};
}
else {
	curDoc.documentPreferences.properties = {pageWidth:210, pageHeight:297, facingPages:false, masterTextFrame:false};
}
curDoc.masterSpreads[0].pages[0].marginPreferences.properties = {top:0, left:0, bottom:0, right:0, columnCount:1};

// mmoriser le nombre de NINAs
var nNinas = (aPulseEnd - aPulseStart) + 1;
// calculer le nombre de pages et les insrer
var nPages = Math.ceil(nNinas/6);
for (var p=1; p<nPages; p++) {
	curDoc.pages.add();
}

// desactiver le rafrachissement
app.scriptPreferences.enableRedraw = false;

var pCtr = aPulseStart;
for (var p=0; p<nPages; p++) {
	// une boucle pour crer les six objets par page
	for (var n=0; n<6; n++) {
		if (orDoc == 0) {
			var yPos = offPos0[n][0];
			var xPos = offPos0[n][1];
		}
		else {
			var yPos = offPos1[n][0];
			var xPos = offPos1[n][1];
		}
		// appeler la fonction qui dessine la NINA actuelle
		drawNINA(p, xPos, yPos, curD, numOfLines, pCtr, bPulse);
		pCtr++;
		if (pCtr > aPulseEnd) { break; }
	}
}

// activer le rafrachissement
app.scriptPreferences.enableRedraw = true;

if (appVers > 6) { // quand CS5 ou plus grand
	// passer le mode de l'cran  "Prsentation"
	app.activeWindow.screenMode = ScreenModeOptions.PRESENTATION_PREVIEW;
}
else {
	// passer le mode de l'cran  "Aperu"
	app.activeWindow.screenMode = ScreenModeOptions.PREVIEW_TO_PAGE;
}

// afficher la premire page
app.activeWindow.activePage = curDoc.pages[0];

// la fonction qui prpare les informations
function getPrefs() {
	var allPrefs = "";
	// lire le fichier contenant les rglages mmoriss
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/NinaGen503.txt");
	}
	else {
		var f = new File("~/Library/Preferences/NinaGen503.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// prparer et afficher le dialogue
function displayDialog(nPts, aPlsS, aPlsE, bPls, rb1, rb2) {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var fieldWidth = 40;
	var aDialog = app.dialogs.add({name:"Generateur NINA"});
	with (aDialog.dialogColumns.add()) {
		with (borderPanels.add()) { 
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Nombre de points"});
				staticTexts.add({staticLabel:"Amplitude A (valeur initiale)"});
				staticTexts.add({staticLabel:"Amplitude A (valeur finale)"});
				staticTexts.add({staticLabel:"Amplitude B (valeur fixe)"});
			}
			with (dialogColumns.add()) {
				var nPointsField = integerEditboxes.add({editValue:nPts, minWidth:fieldWidth});
				var APulseStart  = integerEditboxes.add({editValue:aPlsS,minWidth:fieldWidth});
				var APulseEnd    = integerEditboxes.add({editValue:aPlsE,minWidth:fieldWidth});
				var BPulseField  = integerEditboxes.add({editValue:bPls, minWidth:fieldWidth});
			}
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"L'orientation des pages:"});
			with(aligButtons = radiobuttonGroups.add()) {
				radiobuttonControls.add({staticLabel:"A4 paysage", checkedState:rb1});
				radiobuttonControls.add({staticLabel:"A4 portrait", checkedState:rb2});
			}
		}
	}
	if(aDialog.show() == true) {
		var numOfLines  = nPointsField.editValue;
		var aPulseStart = APulseStart.editValue;
		var aPulseEnd   = APulseEnd.editValue;
		var bPulse      = BPulseField.editValue;
		var orDoc       = aligButtons.selectedButton;
		aDialog.destroy();
		var prefsList = new Array (numOfLines, aPulseStart, aPulseEnd, bPulse, orDoc);
		var prefString = prefsList.join("\n");
		writeResult(prefString);
		return [numOfLines, aPulseStart, aPulseEnd, bPulse, orDoc];
	}
	else{
		aDialog.destroy();
		exit();
	}
}

// crire le rsultat dans un fichier
function writeResult(curPrefs) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/NinaGen503.txt");
	}
	else {
		var f = File("~/Library/Preferences/NinaGen503.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// cette fonction dessine la NINA actuelle
function drawNINA(p, xPos, yPos, curDiameter, numOfLines, aPulse, bPulse) {
	var cur_x, cur_y;
	var aAnchor = new Array(2);
	var arr = new Array(numOfLines);
	// remplir la liste "arr" avec une srie de coordonnes
	for (var ctr = 0; ctr < numOfLines; ctr++) {
		cur_x = ((Math.cos((-2 * Math.PI * aPulse * ctr) / numOfLines) + Math.cos((-2 * Math.PI * bPulse * ctr) / numOfLines)) * curDiameter) + xPos;
		cur_y = ((Math.sin((-2 * Math.PI * aPulse * ctr) / numOfLines) + Math.sin((-2 * Math.PI * bPulse * ctr) / numOfLines)) * curDiameter) + yPos;
		aAnchor = [cur_x, cur_y];
		arr[ctr] = aAnchor;
	}
	with (curDoc){
		var curPage = curDoc.pages[p];
		with (curPage) {
			var newLine = graphicLines.add();
			newLine.strokeWeight = "0.5pt";
			var curPath = newLine.paths.item(0);
			curPath.entirePath = arr;
			curPath.pathType = PathType.closedPath;
			// appliquer les couleurs
			newLine.properties = {fillColor:"None", strokeColor:"Black", strokeTint:-1, strokeAlignment:1936998723};
			// crire les rglages NINA dans l'tiquette de l'objet
			newLine.label = "Longueur du filet: " + curDiameter + " mm\rNombre de points:: " + numOfLines + "\rAmplitude A: " + aPulse + "\rAmplitude B: " + bPulse;
		}
	}
}